## Copyright (C) 2018 John Donoghue <john.donoghue@ieee.org>
## 
## This program is free software: you can redistribute it and/or modify it
## under the terms of the GNU General Public License as published by
## the Free Software Foundation, either version 3 of the License, or
## (at your option) any later version.
## 
## This program is distributed in the hope that it will be useful, but
## WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
## 
## You should have received a copy of the GNU General Public License
## along with this program.  If not, see
## <https://www.gnu.org/licenses/>.

## example program shows a GUI with the inpput of input andalog values

%pkg load arduino
unwind_protect
  ar = arduino();
  pins = ar.availablepins;
  
f = figure('Name', 'Arduino State', 'numbertitle', 'off');

% TODO: attach for close

pos = get(f, 'position');
%pos = [ 0 0 400 300 ];
w = pos(3);
h = pos(4);

%pins = { 'a2' };

run_loop = true;

function finish_cb(hand)
  printf("**********\n");
  run_loop = false;
  %delete(hand);
endfunction

set(f, 'CloseRequestFcn', {@finish_cb});
set(f, 'deletefcn', {@finish_cb});

function led_click(cb, evt, ar, pin)
  printf("click!\n");
  v = get(cb, 'value')
  pin
  ar
  #t = get(cb, 'userdata')
  writeDigitalPin(ar, pin, v);

endfunction

leds = getPinsFromTerminals(ar, getLEDTerminals(ar))

for i = 1:numel(leds)
  pin = leds{i};
  writeDigitalPin(ar,pin,0);
  endfor


row = 0;
for i = 1:2:numel(pins)
  pin = pins{i}
  row = round(i/2);
 
  b = uicontrol(f, 'style', 'text', 'string', toupper(pin), 'units', 'pixels', 'position', [0 h-(25*row) w/4 20]);
  p = uipanel('units', 'pixels', 'position', [w/4 h-(25*row) w/4 20], 'bordertype', 'line');
  b = uicontrol('parent', p, 'style', 'edit', 'string', '', 'position', [1 1 w/4-2 20-2], 'userdata', toupper(pin)); %[w/4 h-(25*i) w/4 20]); %, 'backgroundcolor', [1 1 1], 'foregroundcolor', [0 0 0]);

  if i + 1 <=  numel(pins)
    pin = pins{i+1}
   b = uicontrol(f, 'style', 'text', 'string', toupper(pin), 'units', 'pixels', 'position', [w/2 h-(25*row) w/4 20]);
  p = uipanel('units', 'pixels', 'position', [3*w/4 h-(25*row) w/4 20], 'bordertype', 'line');
  b = uicontrol('parent', p, 'style', 'edit', 'string', '', 'position', [1 1 w/4-2 20-2], 'userdata', toupper(pin)); %[w/4 h-(25*i) w/4 20]); %, 'backgroundcolor', [1 1 1], 'foregroundcolor', [0 0 0]);
   
    
  endif
  
endfor

row ++;
for i = 1:numel(leds)
  pin = leds{i}
  b = uicontrol('parent', f, 'style', 'checkbox', 'string', ['led ' toupper(pin)], 'position', [0 h-(25*row) w/4-2 20-2], 'userdata', ["led-" toupper(pin)])
  get(b,'userdata')
  row++;
  endfor

while ishandle(f) && run_loop == true
  pause(0.001);
  drawnow;
  for i = 1:numel(pins)
    pin = pins{i};
    if (pin(1) == 'a' || pin(1) == 'A')
      v = readVoltage(ar, pin);
    else
      v = readDigitalPin(ar, pin);
    endif
    
    c = findobj('userdata', toupper(pin));
    if !isempty(c)
      set(c, 'string', num2str(v));
    endif
  endfor

  for i = 1:numel(leds)
    pin = leds{i}
    ud = ["led-" toupper(pin)]
    c = findobj('userdata', ["led-" toupper(pin)])
    if !isempty(c)
      get(c,'value')
      writeDigitalPin(ar, pin, get(c,'value'));
    endif
  endfor
endwhile

unwind_protect_cleanup
  clear ar
end_unwind_protect


